package cn.iocoder.yudao.module.member.service.activitypaytable;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activitypaytable.vo.ActivityPayTablePageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.activitypaytable.vo.ActivityPayTableRespVO;
import cn.iocoder.yudao.module.member.controller.admin.activitypaytable.vo.ActivityPayTableSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activitypaytable.ActivityPayTableDO;

import javax.validation.Valid;
import java.time.LocalDate;
import java.util.List;

/**
 * 活动付款 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityPayTableService {

    /**
     * 创建活动付款
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivityPayTable(@Valid ActivityPayTableSaveReqVO createReqVO);

    /**
     * 更新活动付款
     *
     * @param updateReqVO 更新信息
     */
    void updateActivityPayTable(@Valid ActivityPayTableSaveReqVO updateReqVO);

    /**
     * 删除活动付款
     *
     * @param id 编号
     */
    void deleteActivityPayTable(Long id);

    /**
     * 获得活动付款
     *
     * @param id 编号
     * @return 活动付款
     */
    ActivityPayTableDO getActivityPayTable(Long id);

    /**
     * 获得活动付款分页
     *
     * @param pageReqVO 分页查询
     * @return 活动付款分页
     */
    PageResult<ActivityPayTableDO> getActivityPayTablePage(ActivityPayTablePageReqVO pageReqVO);

    void insertBatch(List<ActivityPayTableDO> list);

    PageResult<ActivityPayTableRespVO> getActivityPayTableGroupPage(ActivityPayTablePageReqVO pageReqVO);

    void insertOne(ActivityPayTableDO activityPayTableDO);

    ActivityPayTableDO getOneByActivityIdAndTimeAndNum(Long activityId, LocalDate time, Integer num);

    void updateOne(ActivityPayTableDO activityPayTableDO);
}